#include <utility/ostream.h>
#include <utility/malloc.h>
#include <http.h>
#include <utility/json.h>

__USING_SYS

OStream cout;
HTTPServer * server;

class TemperaturaJsonRestResource: public HTTPServer::JsonRestResource {
public:
	TemperaturaJsonRestResource(const char * path) :
			JsonRestResource(path) {

	}

	char * onRequest(List<char, PathParser::ArgsElement> * args) {
		JsonWriter * writer = new JsonWriter();
		const char * tempKey = "temperatura";
		const char * tempValue = "104F";
		writer->write(tempKey, tempValue);
		char * response = writer->getJson();
		cout << "Temperatura Resource Response=" << response << "\n";
		return response;
	}
};

int main() {

	cout << "HTTP Integration Test\n";

	server = new HTTPServer(80);
	const char * path = "/temperatura";
	HTTPServer::HTTPRestHandler * handler = new HTTPServer::HTTPRestHandler(
			path);
	TemperaturaJsonRestResource * resource = new TemperaturaJsonRestResource(
			path);
	handler->addHandler(resource);
	server->addHandler(handler);

	const char * request_msg = "GET /temperatura HTTP/1.1";
	char * response = server->receivedLocal(request_msg, strlen(request_msg));

	cout << response << "\n ";

	return 0;

}
