#include <utility/ostream.h>
#include <utility/malloc.h>
#include <http.h>

__USING_SYS
;

void test_parser();
void test_parser2();

void test_writer();
void test_writer2();

OStream cout;

int main() {

	cout << "HTTP Utilities Test\n";

	cout << "\nTesting Parser!\n";
	test_parser();
	cout << "\nDone test parse 1!\n";
	test_parser2();
	cout << "\nDone test parse 2!\n";

	cout << "\nTesting Writer!\n";
	test_writer();
	cout << "\nDone test writer 1!\n";
	test_writer2();
	cout << "\nDone test writer 2!\n";

	return 0;
}

void test_parser() {

	char request_msg[80] = "GET / HTTP/1.1";
	cout << "\nMsg=" << request_msg;
	strcat(request_msg, "\r\n");

	strcat(request_msg, "Host: www.google.com");
	strcat(request_msg, "\r\n");

	strcat(request_msg, "\r\n");

	cout << "\nTesting\n ";
	cout << request_msg;

	HTTPRequestParser * parser = new HTTPRequestParser(request_msg);
	if (parser->didParse()) {
		httpRequest req = parser->getRequest();
		if (strcmp(req._requestLine._httpVersion, "HTTP/1.1") != 0) {
			cout << "\nCould not parse version expected=" << "HTTP/1.1"
					<< " but got=" << req._requestLine._httpVersion << "\n ";
		} else {
			cout << "\nPassou httpVersion\n";
		}

		if (strcmp(req._requestLine._method, "GET") != 0) {
			cout << "\nCould not parse version expected=" << "GET"
					<< " but got=" << req._requestLine._method << "\n ";
		} else {
			cout << "\nPassou method\n";
		}

		if (strcmp(req._requestLine._requestUri, "/") != 0) {
			cout << "\nCould not parse version expected=" << "/" << " but got="
					<< req._requestLine._requestUri << "\n ";
		} else {
			cout << "\nPassou requestUri\n";
		}

		if (req._headers.size() == 1) {
			HeaderElement * h = req._headers.head();
			if (strcmp(h->object()->_name, "Host") != 0) {
				cout << "\nCould not parse header expected=" << "Host"
						<< " but got=" << h->object()->_name << "\n ";
			} else {
				cout << "\nPassou header Host\n";
			}
			if (strcmp(h->object()->_value, "www.google.com") != 0) {
				cout << "\nCould not parse header expected="
						<< " www.google.com" << " but got="
						<< h->object()->_value << " eol\n ";
			} else {
				cout << "\nPassou header Host valor\n";
			}
		} else {
			cout << "\nCould not parse headers expected=" << 1 << " but got="
					<< req._headers.size() << "\n ";
		}

	} else {
		cout << "\nCould not parse msg" << "\n ";
	}

}

void test_parser2() {

	char request_msg[80] = "POST /enlighten/calais.asmx/Enlighten HTTP/1.1";
	cout << "\nMsg=" << request_msg;
	strcat(request_msg, "\r\n");

	strcat(request_msg, "Host: api.opencalais.com");
	strcat(request_msg, "\r\n");

	strcat(request_msg, "Content-Type: application/x-www-form-urlencoded");
	strcat(request_msg, "\r\n");

	strcat(request_msg, "Content-Length: 34");
	strcat(request_msg, "\r\n");

	strcat(request_msg, "\r\n");

	strcat(request_msg, "licenseID=string&content=string&paramsXML=string");
	strcat(request_msg, "\r\n");

	cout << "\nTesting2" << request_msg;

	HTTPRequestParser * parser = new HTTPRequestParser(request_msg);
	if (parser->didParse()) {
		httpRequest req = parser->getRequest();
		if (strcmp(req._requestLine._httpVersion, "HTTP/1.1") != 0) {
			cout << "\nCould not parse version expected=" << "HTTP/1.1"
					<< " but got=" << req._requestLine._httpVersion;
		}

		if (strcmp(req._requestLine._method, "POST") != 0) {
			cout << "\nCould not parse version expected=" << "POST"
					<< " but got=" << req._requestLine._method;
		}

		if (strcmp(req._requestLine._requestUri, "/enlighten/calais.asmx/Enlighten") != 0) {
			cout << "\nCould not parse version expected="
					<< "/enlighten/calais.asmx/Enlighten" << " but got="
					<< req._requestLine._requestUri;
		}
		if (req._headers.size() == 3) {
			HeaderElement * he = req._headers.head();
			header * h = he->object();
			if (strcmp(h->_name , "Host")) {
				cout << "\nCould not parse header expected=" << "Host"
						<< " but got=" << h->_name;
			}
			if (strcmp(h->_value, "api.opencalais.com") != 0) {
				cout << "\nCould not parse header expected="
						<< "api.opencalais.com" << " but got=" << h->_value;
			}

			he = he->next();
			h = he->object();
			if (strcmp(h->_name, "Content-Type") != 0) {
				cout << "\nCould not parse header expected=" << "Content-Type"
						<< " but got=" << h->_name;
			}
			if (strcmp(h->_value, "application/x-www-form-urlencoded") != 0) {
				cout << "\nCould not parse header expected="
						<< "application/x-www-form-urlencoded" << " but got="
						<< h->_value;
			}

			he = he->next();
			h = he->object();
			if (strcmp(h->_name, "Content-Length") != 0) {
				cout << "\nCould not parse header expected=" << "Content-Length"
						<< " but got=" << h->_name;
			}
			if (strcmp(h->_value, "34") != 0) {
				cout << "\nCould not parse header expected=" << "34"
						<< " but got=" << h->_value;
			}

		} else {
			cout << "\nCould not parse headers expected=" << 1 << " but got="
					<< req._headers.size();
		}


		//if (strcmp(req._body, "licenseID=string&content=string&paramsXML=string") != 0) {
		//	cout << "\nCould not read body expected="
		//			<< "licenseID=string&content=string&paramsXML=string";
		//	cout	<< "\n but got=" << req._body;

		//}

	} else {
		cout << "\nCould not parse msg=" << request_msg;
	}

}

void test_writer() {
	const char * response_msg = "HTTP/1.1 200 OK\r\n\r\nHello world!\r\n";

	cout << "\nTesting" << response_msg;
	httpResponse * res = new httpResponse();
	cout << "\nCriou o response";
	strcpy(res->_body, "Hello world!");
	strcpy(res->_statusLine._httpVersion, "HTTP/1.1");
	strcpy(res->_statusLine._status, "200");

	cout << "\nTerminou de montar o response";

	HTTPResponseWriter * writer = new HTTPResponseWriter(res);
	cout << "\nCriou o writer";
	const char * writer_response = writer->getResponse();
	if (strcmp(writer_response, response_msg) != 0) {
		cout << "\nWriter Ok=" << writer_response;
	} else {
		cout << "\nCould not write msg=" << response_msg << " got="
				<< writer_response;
	}
	cout << "\nTerminou de montar o writer";
}

void test_writer2() {
	char response_msg[80] = "HTTP/1.1 200 OK";
	strcat(response_msg, "\r\n");

	strcat(response_msg, "Content-Type: text/xml; charset=utf-8");
	strcat(response_msg, "\r\n");

	strcat(response_msg, "Content-Length: 8");
	strcat(response_msg, "\r\n");

	strcat(response_msg, "\r\n");

	strcat(response_msg, "testando");
	strcat(response_msg, "\r\n");

	cout << "\nTesting" << response_msg;

	httpResponse * res = new httpResponse();
	strcpy(res->_body, "testando");
	strcpy(res->_statusLine._httpVersion, "HTTP/1.1");
	strcpy(res->_statusLine._status, "200");
	List<header, HeaderElement> * headers = new List<header, HeaderElement>();

	header * type = new header();
	strcpy(type->_name, "Content-Type");
	strcpy(type->_value, "text/xml; charset=utf-8");
	headers->insert(new HeaderElement(type));

	header * length = new header();
	strcpy(type->_name, "Content-Length");
	strcpy(type->_value, "8");
	headers->insert(new HeaderElement(length));

	res->_headers = *headers;
	strcpy(res->_body, "testando");

	HTTPResponseWriter * writer = new HTTPResponseWriter(res);
	const char * writer_response = writer->getResponse();
	if (strcmp(writer_response, response_msg) != 0) {
		cout << "\nWriter Ok=" << writer_response;
	} else {
		cout << "\nCould not write msg=" << response_msg << " got="
				<< writer_response;
	}

}
