#include <utility/ostream.h>
#include <utility/malloc.h>
#include <utility/json.h>

__USING_SYS
;

void test_write_and_parse();
void expectedWriterOutput22(char expectedWriterOutput2[]);
void expectedWriterOutput1(char expectedWriterOutput[]);

OStream cout;

int main() {

	cout << "JSON Utility Test\n";

	test_write_and_parse();
	cout << "\nDone!\n";

	return 0;
}

void expectedWriterOutput1(char expectedWriterOutput[]) {
	strcat(expectedWriterOutput, "{");
	strcat(expectedWriterOutput, "\"");
	strcat(expectedWriterOutput, "temperatura");
	strcat(expectedWriterOutput, "\"");
	strcat(expectedWriterOutput, " : ");
	strcat(expectedWriterOutput, "\"");
	strcat(expectedWriterOutput, "104F");
	strcat(expectedWriterOutput, "\"");
	strcat(expectedWriterOutput, "}");
}

void expectedWriterOutput22(char expectedWriterOutput2[]) {
	strcat(expectedWriterOutput2, "{");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, "temperatura");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, " : ");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, "104F");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, ",");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, "action");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, " : ");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, "teste");
	strcat(expectedWriterOutput2, "\"");
	strcat(expectedWriterOutput2, "}");
}

void test_write_and_parse() {

	//test temperatura=104F
	const char * tempkey = "temperatura";
	const char * tempvalue = "104F";

	cout << "\nTest1!\n";

	//write
	JsonWriter * writer = new JsonWriter();
	writer->write(tempkey, tempvalue);
	const char * writerOutput = writer->getJson();
	cout << "Wrote=" << writerOutput << "\n";
	//build json to compare and read
	char expectedWriterOutput[80];
	expectedWriterOutput1(expectedWriterOutput);
	cout << "Expects=" << expectedWriterOutput << "\n";

	if (strcmp(writerOutput, expectedWriterOutput) != 0) {
		cout << "\nDid not Match\n";
	} else {
		cout << "passou 1" << "\n";
	}

	//read
	JsonParser * parser = new JsonParser(writerOutput);
	if (parser->didParse()) {
		if (parser->nodes.size() == 1) {
			cout << "passou 2 \n";
			jsonNode * node = parser->nodes.head()->object();
			if (strcmp(node->key, tempkey) != 0
					|| strcmp(node->value, tempvalue) != 0) {
				cout << "key=" << node->key << "\n" ;
				cout << "value=" << node->value << "\n" ;

			} else {
				cout << "passou 3 \n";
			}

		} else {
			cout << "\nNode expected:" << tempkey << ":" << tempvalue
					<< " but none was given \n";
		}
	} else {
		cout << "\nCould not parse\n";
	}
	cout << "\nTest2!\n";

	//test temperatura=104F && action=teste
	//write action
	const char * actionkey = "action";
	const char * actionvalue = "teste";
	writer->write(actionkey, actionvalue);
	const char * writerOutput2 = writer->getJson();
	cout << "Wrote=" << writerOutput2 << "\n";

	//build json to compare and read
	char expectedWriterOutput2[80];
	expectedWriterOutput22(expectedWriterOutput2);
	cout << "Expects=" << expectedWriterOutput2 << "\n";

	if (strcmp(writerOutput2, expectedWriterOutput2) != 0) {
		cout << "\nDid not match\n";
	} else {
		cout << "passou 4\n";
	}

	//parse
	JsonParser * parser2 = new JsonParser(writerOutput2);
	if (parser2->didParse()) {
		if (parser2->nodes.size() == 2) {
			cout << "passou 5 \n";
			JsonParser::JsonElement * e = parser2->nodes.head();
			while (e) {
				jsonNode * node = e->object();
				cout << "will parse next node \n";
				cout << "parsed key=" << node->key << "\n";
				cout << "parsed value=" << node->value << "\n";
				cout << "parsed=" << node->key << ":" << node->value << "\n";
				e = e->next();
				cout << "trying to parse next node \n";
			}
			cout << "finished testing nodes \n";
		} else {
			cout << "\nDid not parse the two values\n";
		}
	} else {
		cout << "\nCould not parse\n";
	}

}
