#include <utility/ostream.h>
#include <utility/malloc.h>
#include <utility/path_parser.h>

__USING_SYS
;

void test_parser();

OStream cout;

int main() {

	cout << "Path Parser Test\n";

	cout << "\nTesting Parser!\n";
	test_parser();
	cout << "\nDone test parse!\n";

	return 0;
}

void test_parser() {

	char* path;
	char* pattern;

	path = "/teste/1/2/33";
	pattern = "/teste/*/*/*";
	cout << "\nTeste 1...";
	PathParser * parser = new PathParser(path, pattern);
	if (parser->didMatch())
		cout << "\nTeste 1 OK\n";
	else
		cout << "\nTeste 1 falhou\n";

	path = "/teste/1/2/33";
	pattern = "/teste/*/*";
	cout << "\nTeste 2...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 2 OK";
	else
		cout << "\nTeste 2 falhou";

	path = "/teste/";
	pattern = "/teste/";
	cout << "\nTeste 3...";
	parser = new PathParser(path, pattern);
	if (parser->didMatch())
		cout << "\nTeste 3 OK";
	else
		cout << "\nTeste 3 falhou";

	path = "/teste/";
	pattern = "/teste/*";
	cout << "\nTeste 4...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 4 OK";
	else
		cout << "\nTeste 4 falhou";

	path = "/teste/1";
	pattern = "/teste/";
	cout << "\nTeste 5...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 5 OK";
	else
		cout << "\nTeste 5 falhou";

	path = "/teste/1";
	pattern = "/teste/*";
	cout << "\nTeste 6...";
	parser = new PathParser(path, pattern);
	if (parser->didMatch())
		cout << "\nTeste 6 OK";
	else
		cout << "\nTeste 6 falhou";

	path = "teste/";
	pattern = "teste/";
	cout << "\nTeste 7...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 7 OK";
	else
		cout << "\nTeste 7 falhou";

	path = "teste/1";
	pattern = "/teste/*";
	cout << "\nTeste 8...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 8 OK";
	else
		cout << "\nTeste 8 falhou";

	path = "/teste/1";
	pattern = "teste/*";
	cout << "\nTeste 9...";
	parser = new PathParser(path, pattern);
	if (!parser->didMatch())
		cout << "\nTeste 9 OK";
	else
		cout << "\nTeste 9 falhou";
}
