#ifndef JSONPARSER_H_
#define JSONPARSER_H_

#include <utility/list.h>
#include <utility/string.h>
#include <tcp.h>

__BEGIN_SYS

struct jsonNode {
	char * key;
	char * value;
};

class JsonParser {

private:
	char * string;

	void parse();
	int readSeparators(int * index, char string[]);


public:
	bool parsed;
	typedef List_Elements::Doubly_Linked<jsonNode> JsonElement;
	List<jsonNode, JsonElement> nodes;

	JsonParser(const char * input) {
		string = new char[strlen(input)];
		strcpy(string,input);
		parsed = false;
		parse();
	}

	bool didParse();
	List<jsonNode, JsonElement> getNodes();

};

class JsonWriter {

public:
	char * json;
	bool hasValues;
	JsonWriter() {
		strcpy(json, "{");
		hasValues = false;}

	void write(const char * key, const char * value);
	char* getJson() {
		char temp2[2];
		strcpy(temp2, json);
		return strcat(temp2, "}");
	}

};

__END_SYS

#endif /* PATHPARSER_H_ */
