/*
 * PathParser.h
 *
 *  Created on: Jun 3, 2012
 *      Author: lucasschmidt
 */
#ifndef PATHPARSER_H_
#define PATHPARSER_H_

#include <utility/list.h>
#include <utility/string.h>
#include <radio.h>

__BEGIN_SYS

// class should receive a pattern like /temperatura/*, where * means its an argument
// and should receive a path like /temperatura/ or /temperatura/20F

class PathParser {

public:
	typedef List_Elements::Doubly_Linked<char> ArgsElement;
	List<char, ArgsElement> args;

	PathParser(char * path, char * pattern) {
		this->pattern = new char[strlen(pattern)];
		strcpy(this->pattern, pattern);
		this->path = new char[strlen(path)];
		strcpy(this->path, path);
		db<TCP>(TRC) << "\nPathParser:: parsing pattern=" << this->pattern << " for path=" << path << "\n";
		matched = false;
		parse();

	}

	bool didMatch();

private:
	char * path;
	char * pattern;
	bool matched;

	void parse();

};

__END_SYS

#endif /* PATHPARSER_H_ */
