#include <utility/json.h>

__BEGIN_SYS

void increaseArrayIfNeeded(int index, int size, char * keyTemp){
	if(index >= size){
		char * temp;
		temp = new char[size+1];
		for(int i =0; i < size; i++){
			temp[i] = keyTemp[i];
		}
		delete[] keyTemp;
		keyTemp = temp;
	}
}

void increaseArraySize(int extraSize, int size, char * keyTemp){
	char * temp;
	temp = new char[size + extraSize];
	for(int i =0; i < size; i++){
		temp[i] = keyTemp[i];
	}
	delete[] keyTemp;
	keyTemp = temp;
}


void JsonWriter::write(const char *key,const char * value) {
	const char * DB_QUOTES = "\"";
	const char * TWO_POINTS = " : ";
	const char * SEPARATOR = ",";


	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	if(hasValues) {
		strcat(json,SEPARATOR);
		db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	} else {
		hasValues = true;
	}
	strcat(json, DB_QUOTES);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, key);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, DB_QUOTES);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, TWO_POINTS);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, DB_QUOTES);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, value);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
	strcat(json, DB_QUOTES);
	db<TCP>(TRC) << "JsonWriter:: "<< json << "\n";
}

bool JsonParser::didParse() {
	return parsed;
}

int JsonParser::readSeparators(int * idx, char string[]) {
	int index = *idx;
	while(string[index] == ' ' || string[index] == '\n') {
		index++;
	}
	return index;
}

void JsonParser::parse() {
	db<TCP>(TRC) << "JsonParser::trying to parse "<< string << "\n";
	if (string[0] != '{') {
		db<TCP>(TRC) << "JsonParser::could not parse "<< string << " because json has to start with {" << "\n";
		return;
	}
	bool continuar = true;
	int index = 1;
	while (continuar) {
		index = readSeparators(&index, string);
		char * keyTemp;
		keyTemp = new char[2];
		char * valueTemp;
		valueTemp = new char[2];
		db<TCP>(TRC) << "JsonParser:: linha 46= " << index << "=" << string[index] << " \n";
		if (string[index] == '\"') {
			index++;
			db<TCP>(TRC) << "JsonParser:: linha 49= " << index << "=" << string[index] <<" \n";
			while (string[index] != '\"') {
				char * temp;
				temp = new char[1];
				temp[0] = string[index];
				strcat(keyTemp, temp);
				db<TCP>(TRC) << "JsonParser:: linha 52= " << index << "=" << string[index] << " keyTemp=" << keyTemp <<" \n";
				index++;
			}
			index++;
			index = readSeparators(&index, string);
			if (string[index] != ':') {
				db<TCP>(TRC) << "JsonParser::could not parse "<< "=" << string[index] << " because was expecting :" << "\n";
				return;
			}
			index++;
			index = readSeparators(&index, string);
			if (string[index] != '\"') {
				db<TCP>(TRC) << "JsonParser::could not parse "<< "=" << string[index] <<" because was expecting double quotes"<< "\n";
				return;
			}
			index++;
			db<TCP>(TRC) << "JsonParser:: linha 69= " << index << "=" << string[index] <<" \n";
			while (string[index] != '\"') {
				char * temp;
				temp = new char[1];
				temp[0] = string[index];
				strcat(valueTemp, temp);
				db<TCP>(TRC) << "JsonParser:: linha 71= " << index << "=" << string[index] << " valueTemp=" << valueTemp <<" \n";
				index++;
			}
			index++;
			jsonNode * node = new jsonNode();
			node->value = new char[strlen(valueTemp)];
			strcpy(node->value, valueTemp);
			node->key = new char[strlen(keyTemp)];
			strcpy(node->key, keyTemp);
			delete[] keyTemp;
			delete[] valueTemp;
			db<TCP>(TRC) << "JsonParser:: found key=" << node->key << "\n";
			db<TCP>(TRC) << "JsonParser:: found value=" << node->value << "\n";
			nodes.insert(new JsonElement(node));
			index = readSeparators(&index, string);
			if (string[index] == '}') {
				continuar = false;
			} else {
				if (string[index] == ',') {
					//keyTemp = {0};
					//valueTemp = {0};
					index++;
				} else {
					db<TCP>(TRC) << "JsonParser::error was expecting , but got=" << string[index] << "\n";
					return;
				}
			}
		} else {
			db<TCP>(TRC) << "JsonParser::could not parse "<< string << " because was expecting double quotes"<< "\n";
			return;
		}
	}
	parsed = true;
}

__END_SYS
