/*
 * path_parser.cc
 *
 *  Created on: Jun 4, 2012
 *      Author: lucasschmidt
 */

#include <utility/path_parser.h>

__BEGIN_SYS

bool PathParser::didMatch() {
	return matched;
}

void PathParser::parse() {
	int pathLen = strlen(path);
	int patternLen = strlen(pattern);
	if(pathLen <= patternLen > 0) {
		int pathIndex = 0;
		int patternIndex = 0;

		if(pattern[patternIndex] == '/') {
			patternIndex++;
			if(path[pathIndex] == '/') {
				pathIndex++;
			} else {
				return;
			}
		} else {
			return;
		}
		while(patternIndex < patternLen) {
			//if its not the beginning, verify if its an argument or a path name
			if(pattern[patternIndex] != '*') { // its a name, we have to match char by char
				while(pattern[patternIndex] != '/' && patternIndex < patternLen) {
					if(pathIndex < pathLen && pattern[patternIndex] == path[pathIndex]) {
						pathIndex++;
						patternIndex++;
					} else {
						return;
					}
				}
			} else { // its an argument
				if (pathIndex >= pathLen)
					return;
				while(pattern[patternIndex] != '/' && patternIndex < patternLen ) {
					char * argument;
					int argIndex = 0;
					while(path[pathIndex] != '/' && pathIndex < pathLen) {
						argument[argIndex] = path[pathIndex];
						argIndex++;
						pathIndex++;
					}
					patternIndex++;
					//store the argument
					if(strlen(argument) > 0) {
						args.insert(new ArgsElement(argument));
					}
				}
			}
			// skip the next '/'
			if (pattern[patternIndex] == '/' && patternIndex < patternLen) {
				if (path[pathIndex] == '/') {
					pathIndex++;
					patternIndex++;
				} else {
					return;
				}
			}
		}
		matched = true;
	}
}

__END_SYS
